unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  lNetComponents, lNet;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button_Device: TButton;
    Button_Power: TButton;
    Button_Config: TButton;
    Button_ON: TButton;
    Button_OFF: TButton;
    Button_GETSTATUS: TButton;
    Edit_Port: TEdit;
    Edit_Host: TEdit;
    LUDPComponent1: TLUDPComponent;
    Memo1: TMemo;
    Panel1: TPanel;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    procedure Button_DeviceClick(Sender: TObject);
    procedure Button_PowerClick(Sender: TObject);
    procedure Button_ConfigClick(Sender: TObject);
    procedure Button_ONClick(Sender: TObject);
    procedure Button_OFFClick(Sender: TObject);
    procedure Button_GETSTATUSClick(Sender: TObject);
    procedure Edit_HostChange(Sender: TObject);
    procedure Edit_PortChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LUDPComponent1Error(const msg: string; aSocket: TLSocket);
    procedure LUDPComponent1Receive(aSocket: TLSocket);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.LUDPComponent1Error(const msg: string; aSocket: TLSocket);
begin
 showmessage(msg);
end;

procedure TForm1.Button_ONClick(Sender: TObject);
var msg : string;
begin
 msg := '{"method":"setState","params":{"state":true}}';
 if LUDPComponent1.Connect(LUDPComponent1.Host, LUDPComponent1.Port) then
  LUDPComponent1.SendMessage(msg, Format('%s:%d', [LUDPComponent1.Host, LUDPComponent1.Port]))
 else
  ShowMessage('Connection failed');
end;

procedure TForm1.Button_ConfigClick(Sender: TObject);
var msg : string;
begin
 msg :='{"method":"getSystemConfig","params":{}}';
 if LUDPComponent1.Connect(LUDPComponent1.Host, LUDPComponent1.Port) then
  LUDPComponent1.SendMessage(msg, Format('%s:%d', [LUDPComponent1.Host, LUDPComponent1.Port]))
 else
  ShowMessage('Connection failed');
end;

procedure TForm1.Button_OFFClick(Sender: TObject);
var msg : string;
begin
 msg := '{"method":"setState","params":{"state":false}}';
 if LUDPComponent1.Connect(LUDPComponent1.Host, LUDPComponent1.Port) then
  LUDPComponent1.SendMessage(msg, Format('%s:%d', [LUDPComponent1.Host, LUDPComponent1.Port]))
 else
  ShowMessage('Connection failed');
end;

procedure TForm1.Button_GETSTATUSClick(Sender: TObject);
var msg : string;
begin
 msg := '{"method":"getPilot","params":{}}';
 if LUDPComponent1.Connect(LUDPComponent1.Host, LUDPComponent1.Port) then
  LUDPComponent1.SendMessage(msg, Format('%s:%d', [LUDPComponent1.Host, LUDPComponent1.Port]))
 else
  ShowMessage('Connection failed');
end;

procedure TForm1.Edit_HostChange(Sender: TObject);
begin
 LUDPComponent1.Host := Edit_Host.Text;
end;

procedure TForm1.Edit_PortChange(Sender: TObject);
begin
 LUDPComponent1.Port := strtoint(Edit_Port.Text);
end;

procedure TForm1.Button_PowerClick(Sender: TObject);
var msg : string;
begin
 msg := '{"method": "getPower"}';
 if LUDPComponent1.Connect(LUDPComponent1.Host, LUDPComponent1.Port) then
  LUDPComponent1.SendMessage(msg, Format('%s:%d', [LUDPComponent1.Host, LUDPComponent1.Port]))
 else
  ShowMessage('Connection failed');
end;

procedure TForm1.Button_DeviceClick(Sender: TObject);
var msg : string;
begin
 msg :='{"method":"getDevInfo","params":{}}';
 if LUDPComponent1.Connect(LUDPComponent1.Host, LUDPComponent1.Port) then
  LUDPComponent1.SendMessage(msg, Format('%s:%d', [LUDPComponent1.Host, LUDPComponent1.Port]))
 else
  ShowMessage('Connection failed');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 LUDPComponent1.Host := Edit_Host.Text;
 LUDPComponent1.Port := strtoint(Edit_Port.Text);
end;

procedure TForm1.LUDPComponent1Receive(aSocket: TLSocket);
var msg : string;
begin
 Memo1.Clear;
 aSocket.GetMessage(msg);
 Memo1.Lines.Add(msg);
end;

end.

